%define vocab_name Mueller
%define edition 7
%define vocab %{vocab_name}%{edition}
%define dict_server dictd
Name: dict-%{vocab}-utf8
Version: 0.8
Release: 9%{?dist}
Summary: V.K. Mueller English-Russian Dictionary, Edition 7
License: Unknown
Group: Text tools

Source0: http://www.chat.ru/~mueller_dic/%{vocab}.tgz
Source1: http://www.math.sunysb.edu/~comech/tools/to-dict.sh
Source2: dictfmt
Source3: %{vocab}-doc.tar.gz 
Source4: dictzip
Source5: mueller2utf8

BuildArchitectures: noarch
BuildRoot: /var/tmp/%{name}-root
Provides: %{name}

Prefix: /usr/share
Requires: dictd >= 1.9
BuildRequires: perl-Unicode-Map8
#dict-tools >= 1.9.1

%description
Electronic version of the Mueller English-Russian dictionary (7th edition)
in dict format and utf8 encoding for use with dictd.

%prep
#rm -rf $RPM_BUILD_ROOT

%setup0 -c
tar xzvf $RPM_SOURCE_DIR/%{vocab}-doc.tar.gz
cp -p Mueller7-doc/README.html .
cp $RPM_SOURCE_DIR/to-dict.sh .
cp $RPM_SOURCE_DIR/dictfmt .

%build
# install -p %SOURCE1 LICENSE
export PATH=$RPM_SOURCE_DIR:$PATH
echo $PATH
export LANG=C
cd usr/local/Mova/
%SOURCE5 %{vocab}GPL.koi > %vocab.utf8
%SOURCE1 --src-data %{vocab}.utf8 %{vocab}.data #&& rm -f %{vocab}.notr
%SOURCE1 --data-dict %{vocab}.data %{vocab} && rm -f %{vocab}.data
%SOURCE1 --expand-index %{vocab}.index %{vocab}.index.exp

%install
mkdir -p $RPM_BUILD_ROOT%prefix/dict
cd usr/local/Mova/
install -m 644 %{vocab}.{index,dict.dz} $RPM_BUILD_ROOT%prefix/dict

%preun
if [ "$1" == "0" ]; then
  if [ -f /etc/dictd.conf ]; then
    echo -n "Unconfiguring dicts: "
    for i in %{vocab} ; do
      echo -n "$i "
      grep -v /usr/share/dict/$i.[id][ni][dc][et] /etc/dictd.conf \
	                > dictd.conf.tmp
    done
    if [ ! -s dictd.conf.tmp ]; then
      grep -v "server localhost" /etc/dict.conf \
	                > dict.conf.tmp
      if [ -s dict.conf.tmp ]; then
         mv dict.conf.tmp /etc/dict.conf
      else
         if [ -f /etc/dict.conf.orig ]; then
            mv /etc/dict.conf.orig /etc/dict.conf
         fi
      fi
      if [ -f /etc/dictd.conf.orig ]; then
         mv -f /etc/dictd.conf.orig /etc/dictd.conf
      fi
      rm dictd.conf.tmp
    else
      mv -f dictd.conf.tmp /etc/dictd.conf
    fi
    echo " "
  else
    if [ -f /etc/dictd.conf.orig ]; then
       rm /etc/dictd.conf.orig
    fi
    if [ -f /etc/dict.conf.orig ]; then
       rm /etc/dict.conf.orig
    fi
  fi
fi

(rpm -q dictd && /etc/init.d/dictd restart) > /dev/null 2>&1
exit 0

%triggerin -- %{dict_server}

# Save standard dictd.conf as dictd.conf.orig
  grep 'Mueller7\|korolew_ruen' /etc/dictd.conf >/dev/null
  if [ $? != 0 ]; then
     cd /etc;
     [ -f dictd.conf ] && mv dictd.conf dictd.conf.orig
     [ -f dict.conf ]  && mv dict.conf dict.conf.orig
  fi

  grep /usr/share/dict/%{vocab}.[id][ni][dc][et] /etc/dictd.conf>/dev/null 2>&1
  if [ $? != "0" ]; then
     for i in %{vocab} ; do
        echo 'database '$i' {   data "/usr/share/dict/'$i'.dict.dz"' \
			                                 >> /etc/dictd.conf
        echo '                  index "/usr/share/dict/'$i'.index" }' \
							  >> /etc/dictd.conf
     done
fi
echo "server 127.0.0.1" > /etc/dict.conf
/etc/init.d/dictd restart > /dev/null 2>&1

LC_ALL=C chkconfig --list dictd | grep on >/dev/null 2>&1 || chkconfig dictd on

%post
if [ ! -f /usr/bin/dictd-cfg-fix ]; then
   cat > /usr/bin/dictd-cfg-fix <<EOF
#!/bin/bash

fix() {
  (rpm -V %{dict_server} | grep ".* */etc/dictd.conf")>/dev/null || \
			            (cd /etc; mv dictd.conf dictd.conf.orig)
  (rpm -V %{dict_server} | grep ".* */etc/dict.conf")>/dev/null || \
                                    (cd /etc; mv dict.conf dict.conf.orig)
     grep /usr/share/dict/%{vocab}.[id][ni][dc][et] /etc/dictd.conf>/dev/null 2>&1
  if [ "$?" != "0" ]; then
     echo 'database '%{vocab}' {   data "/usr/share/dict/'%{vocab}'.dict.dz"' \
	                                           >> /etc/dictd.conf
     echo '                  index "/usr/share/dict/'%{vocab}'.index" }' \
                                                   >> /etc/dictd.conf
  fi
}

service dictd stop >/dev/null 2>&1
STAT=$?
rpm -q dict-Mueller7-utf8 >/dev/null 2>&1 && fix "Mueller7"
rpm -q dict-korolew_ruen >/dev/null 2>&1   && fix "korolew_ruen"
echo "server 127.0.0.1" > /etc/dict.conf
if [ "$STAT" == "0" ]; then
   service dictd start
fi
EOF
fi

chmod a+x /usr/bin/dictd-cfg-fix
%clean
#rm -rf $RPM_BUILD_ROOT

%files
%defattr(644,root,root,755)
%prefix/dict/*
%doc README.html to-dict.sh

%changelog
* Wed Aug 13 2008 Elena Korytko <elena@linux-ink.ru>
- rebuild for NauLinux
* Mon Jan 22 2001 Andrei Elkin <elkin@linux-ink.ru>
- Remove service restarting for possible installion from distro
* Mon Jan 15 2001 Andrei Elkin <elkin@linux-ink.ru>
- carefully test of system status for daeman restart at %post
* Wed Nov 15 2000 Andrei Elkin <elkin@linux-ink.ru>
- 0 version
